#
# Conditional build
%bcond_with	verbose		# verbose build (V=1)
#
Summary:	cgit - a fast webinterface to git
Summary(pl.UTF-8):	cgit - szybki interfejs WWW do gita
Name:		cgit
Version:	0.9.2
Release:	2
License:	GPL v2
Group:		Development/Tools
Source0:	http://git.zx2c4.com/cgit/snapshot/%{name}-%{version}.tar.xz
# Source0-md5:	fe11018eff8d79caad112f4fac64b90f
Source1:	%{name}.conf
Source2:	%{name}-repo.conf
Source3:	%{name}-apache.conf
Source4:	%{name}-httpd.conf
Patch0:		%{name}-system-git.patch
URL:		http://git.zx2c4.com/cgit/about/
BuildRequires:	git-core-devel >= 1.8.3
BuildRequires:	openssl-devel
BuildConflicts:	zlib-devel = 1.2.5-1
Requires:	webapps
Conflicts:	apache-base < 2.4.0-1
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		webapp		cgit
%define		webappdir	%{_sysconfdir}/webapps/%{webapp}
%define		appdir		%{_datadir}/%{webapp}
%define		cgibindir	%{_prefix}/lib/cgi-bin

%define         _noautoreqfiles %{_libdir}/cgit/filters

%description
Cgit is a CGI application implemented in C: it's basically (yet)
another git command, used to generate HTML. Cgit is not forking: all
git operations are performed by linking with libgit.a. It uses a
built-in cache: the generated HTML is stored on disk for the benefit
of later requests.

%description -l pl.UTF-8
Cgit to napisana w C aplikacja CGI - zasadniczo jest to (kolejny)
interfejs do gita, generujący kod HTML. Cgit jest aplikacją
nieforkującą - wszystkie operacje na repozytoriach wykonywane są z
użyciem biblioteki. Aplikacja ta korzysta z cache - wygenerowany kod
HTML zapisany jest na dysku dla kolejnych żądań.

%prep
%setup -q
%patch0 -p1
cp  %{_includedir}/git-core/{Makefile,config.*} git

%build
%{__make} \
	V=1 \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -I/usr/include/git-core" \
	LDFLAGS="%{rpmldflags}" \
	LIBDIR=%{_libdir} \
	CGIT_CONFIG="%{webappdir}/%{webapp}.conf" \
	CGIT_SCRIPT_PATH="%{cgibindir}" \
	%{?with_verbose:V=1}

%install
rm -rf $RPM_BUILD_ROOT

# The same CFLAGS as in %build  stage has to be passed to avoid
# "new build flags" logic in Makefile
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	CFLAGS="%{rpmcflags} -I/usr/include/git-core" \
	CGIT_CONFIG="%{webappdir}/%{webapp}.conf" \
	CGIT_DATA_PATH="%{appdir}" \
	CGIT_SCRIPT_PATH="%{cgibindir}" \
	%{?with_verbose:V=1}

# cache
install -d $RPM_BUILD_ROOT/var/cache/cgit

# webapp stuff
install -d $RPM_BUILD_ROOT%{webappdir}
install %{SOURCE1} $RPM_BUILD_ROOT%{webappdir}
install %{SOURCE2} $RPM_BUILD_ROOT%{webappdir}
install %{SOURCE3} $RPM_BUILD_ROOT%{webappdir}/apache.conf
install %{SOURCE4} $RPM_BUILD_ROOT%{webappdir}/httpd.conf

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{webapp}

%triggerin -- apache-base
%webapp_register httpd %{webapp}

%triggerun -- apache-base
%webapp_unregister httpd %{webapp}

%files
%defattr(644,root,root,755)
%doc README cgitrc.5.txt
%dir %{webappdir}
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/cgit.conf
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/cgit-repo.conf
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,root) %{webappdir}/apache.conf
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,root) %{webappdir}/httpd.conf
%attr(755,root,root) %{cgibindir}/cgit.cgi
%attr(770,root,http) /var/cache/cgit
%{appdir}
%dir %{_prefix}/lib/cgit
%dir %{_prefix}/lib/cgit/filters
%attr(755,root,root) %{_prefix}/lib/cgit/filters/about-formatting.sh
%attr(755,root,root) %{_prefix}/lib/cgit/filters/commit-links.sh
%attr(755,root,root) %{_prefix}/lib/cgit/filters//syntax-highlighting.py
%attr(755,root,root) %{_prefix}/lib/cgit/filters/syntax-highlighting.sh
%{_prefix}/lib/cgit/filters/html-converters
%changelog
* Sun Aug 25 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/cgit.git;a=log;h=master

* Sun Aug 25 2013 Kacper Kornet <draenog@pld-linux.org> b54a649
- rebuild with git-core-1.8.4

* Wed Aug 14 2013 Kacper Kornet <draenog@pld-linux.org> eda47dc
- updated to 0.9.2; new upstream location

* Fri May 17 2013 Jan Rękorajski <baggins@pld-linux.org> 579c7c9
- updated to 0.9.1
- added git patch to update to cgit git master
- added notes patch to fix building with git 1.8
- updated httpd config for apache 2.4

* Wed May 15 2013 Jan Rękorajski <baggins@pld-linux.org> 6e60139
- migrate to apache 2.4
- rel 2

* Sun Oct 17 2010 Karol Krenski <charles@pld-linux.org> 1807596
- proper %install

* Wed Oct 13 2010 Karol Krenski <charles@pld-linux.org> 18ab1fd
- updated to 0.8.3.4

* Sun Aug 08 2010 Adam Gołębiowski <adamg@pld-linux.org> b5f4270
- updated to 0.8.3.3

* Tue Jun 22 2010 shadzik <shadzik@pld-linux.org> 740d29e
- 0.8.3.2

* Sun May 23 2010 Adam Gołębiowski <adamg@pld-linux.org> 7742954
- BC: zlib-devel-1.2.5-1 (see zlib-lfs.patch for details)
- release 2

* Sun May 02 2010 Adam Gołębiowski <adamg@pld-linux.org> adb3e92
- updated to 0.8.3.1; BR: git-core-devel >= 1.7.1-2 (compat/bswap.h)

* Wed Apr 21 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 8c3135f
- release 3

* Mon Apr 12 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 2864b90
- release 2

* Tue Mar 10 2009 Jakub Bogusz <qboosh@pld-linux.org> da36549
- pl fixes, unified caps

* Sat Feb 14 2009 Adam Gołębiowski <adamg@pld-linux.org> 972d356
- fixed typo in previous changelog entry

* Sat Feb 14 2009 Adam Gołębiowski <adamg@pld-linux.org> a113189
- updated to 0.8.2

* Sat Feb 14 2009 Adam Gołębiowski <adamg@pld-linux.org> ca590a4
- updated to 0.8.2

* Thu Dec 11 2008 Adam Gołębiowski <adamg@pld-linux.org> 6815c32
- pass libdir

* Thu Dec 11 2008 Adam Gołębiowski <adamg@pld-linux.org> ca7782e
- cosmetics

* Thu Dec 11 2008 Adam Gołębiowski <adamg@pld-linux.org> 435853a
- use override

* Thu Dec 11 2008 Adam Gołębiowski <adamg@pld-linux.org> 0d4320f
- use system git instead of trying to build local copy

